/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         spice_parse
#define yylex           spice_lex
#define yyerror         spice_error
#define yydebug         spice_debug
#define yynerrs         spice_nerrs
#define yylval          spice_lval
#define yychar          spice_char

/* First part of user prologue.  */
#line 3 "parse_spice.ypp"

/*
 * parse_spice.y - parser for a Spice netlist
 *
 * Copyright (C) 2004, 2005, 2006, 2007, 2009 Stefan Jahn <stefan@lkcc.org>
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this package; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.  
 *
 * $Id$
 *
 */

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#if defined(_WIN32) & not defined(__MINGW32__)
#define strcasecmp stricmp
#endif

#define YYERROR_VERBOSE 42
#define YYDEBUG 1
#define YYMAXDEPTH 1000000

#include "check_spice.h"

// Converts the given string into upper case.
static char * spice_toupper (char * str) {
  for (unsigned int i = 0; i < strlen (str); i++) {
    if (str[i] >= 'a' && str[i] <= 'z') str[i] = toupper (str[i]);
  }
  return str;
}

// Creates a device instance.
static struct definition_t * spice_create_device (char * instance) {
  struct definition_t * def = create_definition ();
  def->action = PROP_COMPONENT;
  def->instance = spice_toupper (instance);
  def->type = (char *) calloc (2, 1);
  def->type[0] = def->instance[0];
  def->line = spice_lineno;
  return def;
}

// Creates an action instance.
static struct definition_t * spice_create_action (char * type,
						  char * instance) {
  struct definition_t * def = create_definition ();
  def->action = PROP_ACTION;
  def->instance = spice_toupper (instance);
  def->type = spice_toupper (type);
  def->line = spice_lineno;
  return def;
}

// Create a string value.
static struct value_t * spice_create_str_value (char * value, int hint) {
  struct value_t * val = create_value ();
  val->ident = spice_toupper (value);
  val->hint |= hint;
  return val;
}

// Create a real value.
static struct value_t * spice_create_val_value (char * value, int hint) {
  struct value_t * val = create_value ();
  val->ident = value;
  val->value = strtod (value, NULL);
  val->hint |= hint;
  return val;
}

// Create a key/value pair.
static struct value_t * spice_create_par_value (char * key, char * value) {
  struct value_t * val = spice_create_str_value (key, HINT_PAIR);
  val->unit = value;
  return val;
}

// Append a string value to the definition.
static void spice_append_str_value (struct definition_t * def,
				    char * value, int hint) {
  struct value_t * val = spice_create_str_value (value, hint);
  def->values = netlist_append_values (def->values, val);
}

// Append a string value to the given values.
static struct value_t * spice_append_str_values (struct value_t * values,
						 char * value, int hint) {
  struct value_t * val = spice_create_str_value (value, hint);
  return netlist_append_values (values, val);
}

// Append a real value to the definition.
static void spice_append_val_value (struct definition_t * def,
				    char * value, int hint) {
  struct value_t * val = spice_create_val_value (value, hint);
  def->values = netlist_append_values (def->values, val);
}

// Append a real value to the given values.
static struct value_t * spice_append_val_values (struct value_t * values,
						 char * value, int hint) {
  struct value_t * val = spice_create_val_value (value, hint);
  return netlist_append_values (values, val);
}


#line 206 "parse_spice.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_SPICE_PARSE_SPICE_HPP_INCLUDED
# define YY_SPICE_PARSE_SPICE_HPP_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int spice_debug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    TitleLine = 258,               /* TitleLine  */
    InvalidCharacter = 259,        /* InvalidCharacter  */
    End = 260,                     /* End  */
    Eol = 261,                     /* Eol  */
    Identifier = 262,              /* Identifier  */
    Digits = 263,                  /* Digits  */
    Floats = 264,                  /* Floats  */
    Nodes = 265,                   /* Nodes  */
    Options = 266,                 /* Options  */
    Function = 267,                /* Function  */
    SUBCKT_Action = 268,           /* SUBCKT_Action  */
    ENDS_Action = 269,             /* ENDS_Action  */
    AC_Action = 270,               /* AC_Action  */
    OP_Action = 271,               /* OP_Action  */
    I_Source = 272,                /* I_Source  */
    SAVE_Action = 273,             /* SAVE_Action  */
    RLC_Device = 274,              /* RLC_Device  */
    L_Device = 275,                /* L_Device  */
    K_Device = 276,                /* K_Device  */
    IV_Source = 277,               /* IV_Source  */
    GE_Source = 278,               /* GE_Source  */
    FH_Source = 279,               /* FH_Source  */
    V_Source = 280,                /* V_Source  */
    Diode_Device = 281,            /* Diode_Device  */
    Bipolar_Device = 282,          /* Bipolar_Device  */
    JFET_Device = 283,             /* JFET_Device  */
    MOSFET_Device = 284,           /* MOSFET_Device  */
    MESFET_Device = 285,           /* MESFET_Device  */
    MODEL_Action = 286,            /* MODEL_Action  */
    MODEL_Spec = 287,              /* MODEL_Spec  */
    TRAN_Action = 288,             /* TRAN_Action  */
    PLOT_Action = 289,             /* PLOT_Action  */
    VoltFunc = 290,                /* VoltFunc  */
    CurrFunc = 291,                /* CurrFunc  */
    DC_Action = 292,               /* DC_Action  */
    PRINT_Action = 293,            /* PRINT_Action  */
    OPTIONS_Action = 294,          /* OPTIONS_Action  */
    WIDTH_Action = 295,            /* WIDTH_Action  */
    NOISE_Action = 296,            /* NOISE_Action  */
    PZ_Action = 297,               /* PZ_Action  */
    CurVol = 298,                  /* CurVol  */
    PoleZero = 299,                /* PoleZero  */
    ALL_Special = 300,             /* ALL_Special  */
    X_Device = 301,                /* X_Device  */
    O_Device = 302,                /* O_Device  */
    ModelProps = 303,              /* ModelProps  */
    OFF_Special = 304,             /* OFF_Special  */
    IC_Special = 305,              /* IC_Special  */
    SIM_Type = 306,                /* SIM_Type  */
    TEMP_Special = 307,            /* TEMP_Special  */
    MOS_Special = 308,             /* MOS_Special  */
    B_Source = 309,                /* B_Source  */
    DISTO_Action = 310,            /* DISTO_Action  */
    INCLUDE_Action = 311,          /* INCLUDE_Action  */
    File = 312,                    /* File  */
    BranchFunc = 313,              /* BranchFunc  */
    NODESET_Action = 314,          /* NODESET_Action  */
    T_Device = 315,                /* T_Device  */
    U_Device = 316,                /* U_Device  */
    S_Device = 317,                /* S_Device  */
    W_Device = 318,                /* W_Device  */
    ON_Special = 319,              /* ON_Special  */
    TF_Action = 320,               /* TF_Action  */
    SENS_Action = 321,             /* SENS_Action  */
    FOUR_Action = 322,             /* FOUR_Action  */
    OpFunc = 323,                  /* OpFunc  */
    Behave = 324,                  /* Behave  */
    TC_Special = 325,              /* TC_Special  */
    TEMP_Action = 326              /* TEMP_Action  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define TitleLine 258
#define InvalidCharacter 259
#define End 260
#define Eol 261
#define Identifier 262
#define Digits 263
#define Floats 264
#define Nodes 265
#define Options 266
#define Function 267
#define SUBCKT_Action 268
#define ENDS_Action 269
#define AC_Action 270
#define OP_Action 271
#define I_Source 272
#define SAVE_Action 273
#define RLC_Device 274
#define L_Device 275
#define K_Device 276
#define IV_Source 277
#define GE_Source 278
#define FH_Source 279
#define V_Source 280
#define Diode_Device 281
#define Bipolar_Device 282
#define JFET_Device 283
#define MOSFET_Device 284
#define MESFET_Device 285
#define MODEL_Action 286
#define MODEL_Spec 287
#define TRAN_Action 288
#define PLOT_Action 289
#define VoltFunc 290
#define CurrFunc 291
#define DC_Action 292
#define PRINT_Action 293
#define OPTIONS_Action 294
#define WIDTH_Action 295
#define NOISE_Action 296
#define PZ_Action 297
#define CurVol 298
#define PoleZero 299
#define ALL_Special 300
#define X_Device 301
#define O_Device 302
#define ModelProps 303
#define OFF_Special 304
#define IC_Special 305
#define SIM_Type 306
#define TEMP_Special 307
#define MOS_Special 308
#define B_Source 309
#define DISTO_Action 310
#define INCLUDE_Action 311
#define File 312
#define BranchFunc 313
#define NODESET_Action 314
#define T_Device 315
#define U_Device 316
#define S_Device 317
#define W_Device 318
#define ON_Special 319
#define TF_Action 320
#define SENS_Action 321
#define FOUR_Action 322
#define OpFunc 323
#define Behave 324
#define TC_Special 325
#define TEMP_Action 326

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 146 "parse_spice.ypp"

  char * ident;
  char * str;
  double d;
  struct definition_t * definition;
  struct definition_t * subcircuit;
  struct value_t * value;

#line 410 "parse_spice.cpp"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE spice_lval;


int spice_parse (void);


#endif /* !YY_SPICE_PARSE_SPICE_HPP_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TitleLine = 3,                  /* TitleLine  */
  YYSYMBOL_InvalidCharacter = 4,           /* InvalidCharacter  */
  YYSYMBOL_End = 5,                        /* End  */
  YYSYMBOL_Eol = 6,                        /* Eol  */
  YYSYMBOL_Identifier = 7,                 /* Identifier  */
  YYSYMBOL_Digits = 8,                     /* Digits  */
  YYSYMBOL_Floats = 9,                     /* Floats  */
  YYSYMBOL_Nodes = 10,                     /* Nodes  */
  YYSYMBOL_Options = 11,                   /* Options  */
  YYSYMBOL_Function = 12,                  /* Function  */
  YYSYMBOL_SUBCKT_Action = 13,             /* SUBCKT_Action  */
  YYSYMBOL_ENDS_Action = 14,               /* ENDS_Action  */
  YYSYMBOL_AC_Action = 15,                 /* AC_Action  */
  YYSYMBOL_OP_Action = 16,                 /* OP_Action  */
  YYSYMBOL_I_Source = 17,                  /* I_Source  */
  YYSYMBOL_SAVE_Action = 18,               /* SAVE_Action  */
  YYSYMBOL_RLC_Device = 19,                /* RLC_Device  */
  YYSYMBOL_L_Device = 20,                  /* L_Device  */
  YYSYMBOL_K_Device = 21,                  /* K_Device  */
  YYSYMBOL_IV_Source = 22,                 /* IV_Source  */
  YYSYMBOL_GE_Source = 23,                 /* GE_Source  */
  YYSYMBOL_FH_Source = 24,                 /* FH_Source  */
  YYSYMBOL_V_Source = 25,                  /* V_Source  */
  YYSYMBOL_Diode_Device = 26,              /* Diode_Device  */
  YYSYMBOL_Bipolar_Device = 27,            /* Bipolar_Device  */
  YYSYMBOL_JFET_Device = 28,               /* JFET_Device  */
  YYSYMBOL_MOSFET_Device = 29,             /* MOSFET_Device  */
  YYSYMBOL_MESFET_Device = 30,             /* MESFET_Device  */
  YYSYMBOL_MODEL_Action = 31,              /* MODEL_Action  */
  YYSYMBOL_MODEL_Spec = 32,                /* MODEL_Spec  */
  YYSYMBOL_TRAN_Action = 33,               /* TRAN_Action  */
  YYSYMBOL_PLOT_Action = 34,               /* PLOT_Action  */
  YYSYMBOL_VoltFunc = 35,                  /* VoltFunc  */
  YYSYMBOL_CurrFunc = 36,                  /* CurrFunc  */
  YYSYMBOL_DC_Action = 37,                 /* DC_Action  */
  YYSYMBOL_PRINT_Action = 38,              /* PRINT_Action  */
  YYSYMBOL_OPTIONS_Action = 39,            /* OPTIONS_Action  */
  YYSYMBOL_WIDTH_Action = 40,              /* WIDTH_Action  */
  YYSYMBOL_NOISE_Action = 41,              /* NOISE_Action  */
  YYSYMBOL_PZ_Action = 42,                 /* PZ_Action  */
  YYSYMBOL_CurVol = 43,                    /* CurVol  */
  YYSYMBOL_PoleZero = 44,                  /* PoleZero  */
  YYSYMBOL_ALL_Special = 45,               /* ALL_Special  */
  YYSYMBOL_X_Device = 46,                  /* X_Device  */
  YYSYMBOL_O_Device = 47,                  /* O_Device  */
  YYSYMBOL_ModelProps = 48,                /* ModelProps  */
  YYSYMBOL_OFF_Special = 49,               /* OFF_Special  */
  YYSYMBOL_IC_Special = 50,                /* IC_Special  */
  YYSYMBOL_SIM_Type = 51,                  /* SIM_Type  */
  YYSYMBOL_TEMP_Special = 52,              /* TEMP_Special  */
  YYSYMBOL_MOS_Special = 53,               /* MOS_Special  */
  YYSYMBOL_B_Source = 54,                  /* B_Source  */
  YYSYMBOL_DISTO_Action = 55,              /* DISTO_Action  */
  YYSYMBOL_INCLUDE_Action = 56,            /* INCLUDE_Action  */
  YYSYMBOL_File = 57,                      /* File  */
  YYSYMBOL_BranchFunc = 58,                /* BranchFunc  */
  YYSYMBOL_NODESET_Action = 59,            /* NODESET_Action  */
  YYSYMBOL_T_Device = 60,                  /* T_Device  */
  YYSYMBOL_U_Device = 61,                  /* U_Device  */
  YYSYMBOL_S_Device = 62,                  /* S_Device  */
  YYSYMBOL_W_Device = 63,                  /* W_Device  */
  YYSYMBOL_ON_Special = 64,                /* ON_Special  */
  YYSYMBOL_TF_Action = 65,                 /* TF_Action  */
  YYSYMBOL_SENS_Action = 66,               /* SENS_Action  */
  YYSYMBOL_FOUR_Action = 67,               /* FOUR_Action  */
  YYSYMBOL_OpFunc = 68,                    /* OpFunc  */
  YYSYMBOL_Behave = 69,                    /* Behave  */
  YYSYMBOL_TC_Special = 70,                /* TC_Special  */
  YYSYMBOL_TEMP_Action = 71,               /* TEMP_Action  */
  YYSYMBOL_YYACCEPT = 72,                  /* $accept  */
  YYSYMBOL_Input = 73,                     /* Input  */
  YYSYMBOL_InputList = 74,                 /* InputList  */
  YYSYMBOL_InputLine = 75,                 /* InputLine  */
  YYSYMBOL_DefinitionLine = 76,            /* DefinitionLine  */
  YYSYMBOL_TC_Value_1 = 77,                /* TC_Value_1  */
  YYSYMBOL_TC_Value_2 = 78,                /* TC_Value_2  */
  YYSYMBOL_IC_Condition_1 = 79,            /* IC_Condition_1  */
  YYSYMBOL_IC_Condition_2 = 80,            /* IC_Condition_2  */
  YYSYMBOL_IC_Condition_3 = 81,            /* IC_Condition_3  */
  YYSYMBOL_IC_Condition_4 = 82,            /* IC_Condition_4  */
  YYSYMBOL_Output_Range = 83,              /* Output_Range  */
  YYSYMBOL_VOLTAGE_Output = 84,            /* VOLTAGE_Output  */
  YYSYMBOL_IV_Reference = 85,              /* IV_Reference  */
  YYSYMBOL_CURRENT_Output = 86,            /* CURRENT_Output  */
  YYSYMBOL_PLOT_List = 87,                 /* PLOT_List  */
  YYSYMBOL_SWITCH_State = 88,              /* SWITCH_State  */
  YYSYMBOL_PRINT_List = 89,                /* PRINT_List  */
  YYSYMBOL_OPTIONS_List = 90,              /* OPTIONS_List  */
  YYSYMBOL_MODEL_List = 91,                /* MODEL_List  */
  YYSYMBOL_NODESET_List = 92,              /* NODESET_List  */
  YYSYMBOL_DEVICE_List_1 = 93,             /* DEVICE_List_1  */
  YYSYMBOL_DEVICE_List_2 = 94,             /* DEVICE_List_2  */
  YYSYMBOL_DEVICE_List_3 = 95,             /* DEVICE_List_3  */
  YYSYMBOL_MODEL_Ident = 96,               /* MODEL_Ident  */
  YYSYMBOL_DC_List = 97,                   /* DC_List  */
  YYSYMBOL_Value = 98,                     /* Value  */
  YYSYMBOL_Node = 99,                      /* Node  */
  YYSYMBOL_FH_Node = 100,                  /* FH_Node  */
  YYSYMBOL_PairList = 101,                 /* PairList  */
  YYSYMBOL_ValueList = 102,                /* ValueList  */
  YYSYMBOL_NodeValueList = 103,            /* NodeValueList  */
  YYSYMBOL_NodeList = 104,                 /* NodeList  */
  YYSYMBOL_VSourceList = 105,              /* VSourceList  */
  YYSYMBOL_Expr = 106,                     /* Expr  */
  YYSYMBOL_ExprList = 107,                 /* ExprList  */
  YYSYMBOL_Subcircuit = 108,               /* Subcircuit  */
  YYSYMBOL_BeginSub = 109,                 /* BeginSub  */
  YYSYMBOL_SubBody = 110,                  /* SubBody  */
  YYSYMBOL_SubCkt_Ident = 111,             /* SubCkt_Ident  */
  YYSYMBOL_EndSub = 112,                   /* EndSub  */
  YYSYMBOL_SubBodyLine = 113               /* SubBodyLine  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  113
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   691

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  72
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  42
/* YYNRULES -- Number of rules.  */
#define YYNRULES  149
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  358

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   326


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   182,   182,   184,   187,   190,   196,   197,   201,   206,
     213,   217,   225,   234,   242,   250,   258,   266,   275,   282,
     289,   297,   312,   317,   326,   342,   347,   355,   362,   370,
     379,   388,   398,   409,   419,   428,   433,   439,   444,   448,
     453,   458,   464,   469,   475,   480,   485,   490,   497,   507,
     513,   523,   532,   541,   550,   559,   569,   573,   577,   581,
     585,   589,   593,   598,   606,   614,   621,   629,   637,   645,
     655,   666,   674,   680,   686,   696,   696,   699,   705,   711,
     719,   720,   723,   727,   730,   736,   737,   740,   745,   746,
     749,   754,   755,   759,   765,   766,   770,   776,   777,   786,
     787,   791,   795,   799,   804,   805,   809,   813,   817,   820,
     826,   827,   831,   835,   839,   843,   848,   848,   851,   861,
     861,   863,   863,   863,   865,   865,   867,   868,   874,   875,
     881,   882,   886,   892,   893,   899,   900,   907,   914,   915,
     921,   929,   935,   936,   947,   950,   951,   955,   961,   962
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TitleLine",
  "InvalidCharacter", "End", "Eol", "Identifier", "Digits", "Floats",
  "Nodes", "Options", "Function", "SUBCKT_Action", "ENDS_Action",
  "AC_Action", "OP_Action", "I_Source", "SAVE_Action", "RLC_Device",
  "L_Device", "K_Device", "IV_Source", "GE_Source", "FH_Source",
  "V_Source", "Diode_Device", "Bipolar_Device", "JFET_Device",
  "MOSFET_Device", "MESFET_Device", "MODEL_Action", "MODEL_Spec",
  "TRAN_Action", "PLOT_Action", "VoltFunc", "CurrFunc", "DC_Action",
  "PRINT_Action", "OPTIONS_Action", "WIDTH_Action", "NOISE_Action",
  "PZ_Action", "CurVol", "PoleZero", "ALL_Special", "X_Device", "O_Device",
  "ModelProps", "OFF_Special", "IC_Special", "SIM_Type", "TEMP_Special",
  "MOS_Special", "B_Source", "DISTO_Action", "INCLUDE_Action", "File",
  "BranchFunc", "NODESET_Action", "T_Device", "U_Device", "S_Device",
  "W_Device", "ON_Special", "TF_Action", "SENS_Action", "FOUR_Action",
  "OpFunc", "Behave", "TC_Special", "TEMP_Action", "$accept", "Input",
  "InputList", "InputLine", "DefinitionLine", "TC_Value_1", "TC_Value_2",
  "IC_Condition_1", "IC_Condition_2", "IC_Condition_3", "IC_Condition_4",
  "Output_Range", "VOLTAGE_Output", "IV_Reference", "CURRENT_Output",
  "PLOT_List", "SWITCH_State", "PRINT_List", "OPTIONS_List", "MODEL_List",
  "NODESET_List", "DEVICE_List_1", "DEVICE_List_2", "DEVICE_List_3",
  "MODEL_Ident", "DC_List", "Value", "Node", "FH_Node", "PairList",
  "ValueList", "NodeValueList", "NodeList", "VSourceList", "Expr",
  "ExprList", "Subcircuit", "BeginSub", "SubBody", "SubCkt_Ident",
  "EndSub", "SubBodyLine", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-238)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-124)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     558,   216,  -238,    28,    30,    52,    83,   290,    27,   290,
     290,   283,   290,   290,   290,   290,   290,    11,   165,    48,
      31,    78,    12,    89,    90,   290,   290,   290,   100,    30,
      44,    77,   290,   290,   290,   290,   109,   112,   116,   165,
     128,   138,   216,  -238,  -238,   620,   160,  -238,   290,   165,
     163,  -238,  -238,  -238,  -238,  -238,   290,   162,   290,   290,
    -238,  -238,   283,   290,   290,   290,   290,   290,  -238,  -238,
     148,  -238,  -238,   165,   182,   132,  -238,  -238,  -238,   165,
     113,   290,   167,   125,  -238,  -238,   132,   132,   214,  -238,
     165,    12,   217,   165,   218,    19,   290,   290,   224,   290,
    -238,   227,   230,   290,   235,   290,   290,   290,   290,  -238,
    -238,  -238,   245,  -238,  -238,  -238,  -238,  -238,  -238,   238,
     620,  -238,   253,  -238,  -238,    95,   165,   201,    22,    -9,
      11,   290,   290,   290,   290,    21,  -238,  -238,   140,   140,
     254,   165,  -238,   258,   290,  -238,   262,   263,  -238,  -238,
    -238,    12,  -238,  -238,    89,  -238,    30,   290,  -238,  -238,
     290,  -238,  -238,   165,  -238,   290,   290,   290,   248,  -238,
      28,  -238,  -238,  -238,   150,    -5,   274,    30,    30,   278,
      33,   290,   165,    86,   176,   179,    11,   290,    11,   165,
      21,   279,   206,   132,  -238,   165,   132,  -238,  -238,   165,
    -238,  -238,  -238,  -238,  -238,  -238,   280,   290,   290,    77,
     290,    11,   290,    11,  -238,   289,   293,   165,   187,   165,
     295,   296,    89,   306,  -238,   308,  -238,  -238,  -238,   187,
     165,   309,  -238,   264,   176,   165,   165,   176,  -238,   176,
     195,   102,   179,   102,    11,   102,    21,  -238,  -238,  -238,
    -238,  -238,  -238,  -238,   273,    11,  -238,    89,    89,    11,
      41,  -238,  -238,   187,   187,   311,   165,  -238,  -238,   312,
    -238,  -238,   313,   314,  -238,   264,   187,  -238,  -238,   176,
    -238,  -238,   102,   165,   165,   165,   102,  -238,   102,   102,
      11,  -238,   154,  -238,  -238,   277,   316,    32,   317,    41,
    -238,  -238,   321,  -238,  -238,  -238,  -238,  -238,  -238,  -238,
    -238,   322,  -238,  -238,   165,   102,   102,  -238,  -238,  -238,
     102,   154,   165,   165,   165,   154,  -238,   154,   323,  -238,
    -238,   165,   325,  -238,   326,  -238,  -238,  -238,  -238,  -238,
    -238,  -238,   165,   154,   154,  -238,  -238,  -238,   165,  -238,
    -238,   165,  -238,  -238,   165,  -238,   165,  -238
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       6,     6,    10,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   128,     0,
       0,    88,    91,   126,     0,     0,   133,     0,     0,     0,
       0,    97,     0,     0,     0,     0,     0,     0,     0,   128,
       0,     4,     6,     9,     8,   142,     5,   144,   133,   128,
       0,    56,    57,   123,   121,   122,     0,     0,     0,     0,
     125,   124,     0,     0,     0,     0,     0,     0,   116,   117,
       0,   119,   120,   128,     0,    80,    38,    75,    76,     0,
       0,     0,     0,    88,    78,    79,    80,    80,     0,    72,
       0,    91,     0,     0,     0,     0,     0,   133,     0,     0,
      61,     0,     0,     0,     0,     0,     0,     0,     0,    59,
      58,    60,     0,     1,     2,     7,   149,   147,   148,     0,
     142,     3,     0,   137,    37,     0,     0,   138,     0,     0,
       0,     0,     0,     0,     0,    94,   129,    35,    80,    80,
       0,     0,    39,     0,    73,    77,     0,     0,    89,    90,
      42,    91,    92,    44,   126,    46,     0,     0,   134,    49,
       0,    62,    63,     0,    64,     0,     0,     0,     0,    45,
     145,   140,   143,   141,   126,   126,     0,   138,   138,     0,
       0,     0,     0,     0,    99,     0,     0,     0,     0,     0,
      94,     0,   121,    80,    81,     0,    80,    83,    36,     0,
      40,    74,    43,    41,    93,   127,     0,     0,     0,    97,
       0,     0,     0,     0,   146,     0,     0,   116,   130,     0,
       0,     0,   126,     0,    18,     0,   139,    19,    22,   130,
       0,     0,    25,   135,    99,     0,     0,    99,    28,    99,
     116,   104,     0,   104,     0,   104,    94,    95,    27,    82,
      71,    84,   118,    47,     0,     0,    98,   126,   126,     0,
      85,    13,    14,   130,   130,     0,    65,    15,    16,     0,
      11,    20,     0,     0,    26,   135,   130,   102,    67,    99,
     103,   101,   104,     0,     0,     0,   104,    30,   104,   104,
       0,    29,   110,    34,    96,     0,     0,     0,     0,    85,
      87,    86,     0,   132,   131,    17,    66,    12,    21,    23,
     136,     0,   100,   107,     0,   104,   104,   108,   106,    31,
     104,   110,     0,     0,     0,   110,    33,   110,     0,    52,
      54,     0,     0,    53,     0,    51,    24,    68,   105,   109,
      32,   114,     0,   110,   110,   115,   113,    48,     0,    55,
      50,     0,   111,   112,     0,    69,     0,    70
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -238,  -238,    45,  -238,   -40,  -238,  -238,  -238,  -238,  -238,
    -238,   196,   -10,   239,   -17,   -62,    49,   266,   -88,  -175,
     141,  -217,  -237,   -33,  -118,   267,   -18,   330,   291,  -141,
       1,   -85,   -38,    76,    -3,  -124,   -36,  -238,   232,   184,
    -238,  -238
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    40,    41,    42,    43,   220,   221,   237,   286,   325,
     332,   193,   138,    79,   139,   140,   302,    88,    92,   191,
     104,   238,   287,   326,    70,    80,   288,    89,    62,    94,
      74,   265,    98,   276,   178,   179,    44,    45,   119,    48,
     171,   120
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      73,    50,   217,   152,    87,   117,   291,   174,   293,   118,
     122,    86,   184,   205,    95,   247,   182,   277,    68,    90,
     280,    73,   281,    91,   148,   149,   101,    69,   189,    53,
      54,    73,    55,   216,   223,    47,    77,    76,   330,   228,
     112,   229,    49,    69,    78,   313,    46,    57,    77,   317,
     123,   318,   319,   225,   226,    73,    78,   222,    51,   158,
     183,   141,   312,   204,   218,   219,    87,   241,   243,   190,
     245,   294,   151,    86,   136,   154,   194,   197,   338,   339,
     117,   269,   331,   340,   118,    53,    54,   115,    55,    52,
     300,   180,   232,   258,   233,   260,    93,    53,    54,    75,
      55,   102,    68,    71,    72,   301,   100,   175,   176,   177,
      71,    72,   103,    81,    82,   109,   297,   298,   110,   142,
     195,   195,   111,   199,   289,    81,   292,    69,   113,    83,
      77,   249,    53,    54,   251,    55,    84,   296,    78,    53,
      54,   299,    55,   114,   272,   209,    85,    53,   192,    72,
      55,   282,   283,   206,   284,   285,   215,    93,    71,    72,
      81,    82,    71,    72,   231,   121,   239,    81,    82,   124,
     146,   246,   320,    71,    72,    81,    82,   250,   303,   304,
     135,   252,   126,    84,    71,    72,   240,    54,   137,    55,
      84,   311,   145,    85,    53,    54,   263,    55,    84,   154,
      85,   266,  -123,   321,   322,  -123,   323,   324,    85,    71,
      72,    69,   273,    49,  -119,  -119,   239,   278,   279,   239,
     150,   239,     2,   153,   155,   234,   235,  -123,   236,     3,
     159,     4,     5,   161,     6,     7,   162,     8,     9,    10,
      11,   164,    12,    13,    14,    15,    16,    17,   306,    18,
      19,   169,   170,    20,    21,    22,    23,    24,    25,   173,
     198,   239,    26,    27,   200,   314,   315,   316,   202,   203,
      28,    29,    30,   213,   327,    31,    32,    33,    34,    35,
     224,    36,    37,    38,   227,   248,   253,    39,   341,   275,
      53,    54,   345,    55,   346,   261,   337,    53,    54,   262,
      55,   267,   268,   327,   342,   343,   344,   327,    60,   327,
     352,   353,   270,   348,   271,   274,   295,   305,   307,   308,
     309,   328,   329,   333,   351,   327,   327,   335,   336,   347,
     354,   349,   350,   355,   156,   196,   356,    56,   357,    58,
      59,    61,    63,    64,    65,    66,    67,   143,   334,   147,
     256,   310,   172,   129,   214,    96,    97,    99,     0,     0,
       0,     0,   105,   106,   107,   108,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    97,     0,
       0,     0,     0,     0,     0,     0,   125,     0,   127,   128,
       0,     0,    61,   130,   131,   132,   133,   134,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   144,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   157,    97,     0,   160,
       0,     0,     0,   163,     0,   165,   166,   167,   168,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   181,     0,
       0,   185,   186,   187,   188,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   201,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   207,     0,     0,
     208,     0,     0,     0,     0,   210,   211,   212,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,     0,     0,     0,   242,     0,   244,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   254,   255,     0,
     257,     0,   259,     0,     0,     0,     0,     0,   264,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   264,
       0,     1,     0,     0,     2,     0,     0,     0,     0,     0,
       0,     3,   290,     4,     5,     0,     6,     7,     0,     8,
       9,    10,    11,     0,    12,    13,    14,    15,    16,    17,
       0,    18,    19,   264,   264,    20,    21,    22,    23,    24,
      25,     0,     0,     0,    26,    27,   264,     0,     0,     0,
       0,     0,    28,    29,    30,     0,     0,    31,    32,    33,
      34,    35,     0,    36,    37,    38,   116,     0,     0,    39,
       0,     0,     0,     3,     0,     4,     5,     0,     6,     7,
       0,     8,     9,    10,    11,     0,    12,    13,    14,    15,
      16,    17,     0,    18,    19,     0,     0,    20,    21,    22,
      23,    24,    25,     0,     0,     0,    26,    27,     0,     0,
       0,     0,     0,     0,    28,    29,    30,     0,     0,    31,
      32,    33,    34,    35,     0,    36,    37,    38,     0,     0,
       0,    39
};

static const yytype_int16 yycheck[] =
{
      18,     4,     7,    91,    21,    45,   243,   125,   245,    45,
      48,    21,   130,   154,    24,   190,    25,   234,     7,     7,
     237,    39,   239,    11,    86,    87,    29,    32,     7,     7,
       8,    49,    10,   174,   175,     7,    17,     6,     6,     6,
      39,     8,    12,    32,    25,   282,     1,    20,    17,   286,
      49,   288,   289,   177,   178,    73,    25,   175,     6,    97,
      69,    79,   279,   151,    69,    70,    83,   185,   186,    48,
     188,   246,    90,    83,    73,    93,   138,   139,   315,   316,
     120,   222,    50,   320,   120,     7,     8,    42,    10,     6,
      49,    69,     6,   211,     8,   213,     7,     7,     8,    51,
      10,    57,     7,     8,     9,    64,     6,   125,   126,   127,
       8,     9,    35,    35,    36,     6,   257,   258,     6,     6,
     138,   139,     6,   141,   242,    35,   244,    32,     0,    51,
      17,   193,     7,     8,   196,    10,    58,   255,    25,     7,
       8,   259,    10,     5,   229,   163,    68,     7,     8,     9,
      10,    49,    50,   156,    52,    53,   174,     7,     8,     9,
      35,    36,     8,     9,   182,     5,   184,    35,    36,     6,
      45,   189,   290,     8,     9,    35,    36,   195,   263,   264,
      32,   199,    20,    58,     8,     9,     7,     8,     6,    10,
      58,   276,    25,    68,     7,     8,     9,    10,    58,   217,
      68,   219,     7,    49,    50,    10,    52,    53,    68,     8,
       9,    32,   230,    12,     8,     9,   234,   235,   236,   237,
       6,   239,     6,     6,     6,    49,    50,    32,    52,    13,
       6,    15,    16,     6,    18,    19,     6,    21,    22,    23,
      24,     6,    26,    27,    28,    29,    30,    31,   266,    33,
      34,     6,    14,    37,    38,    39,    40,    41,    42,     6,
       6,   279,    46,    47,     6,   283,   284,   285,     6,     6,
      54,    55,    56,    25,   292,    59,    60,    61,    62,    63,
       6,    65,    66,    67,     6,     6,     6,    71,   321,    25,
       7,     8,   325,    10,   327,     6,   314,     7,     8,     6,
      10,     6,     6,   321,   322,   323,   324,   325,    25,   327,
     343,   344,     6,   331,     6,     6,    43,     6,     6,     6,
       6,    44,     6,     6,   342,   343,   344,     6,     6,     6,
     348,     6,     6,   351,    95,   139,   354,     7,   356,     9,
      10,    11,    12,    13,    14,    15,    16,    80,   299,    83,
     209,   275,   120,    62,   170,    25,    26,    27,    -1,    -1,
      -1,    -1,    32,    33,    34,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    58,    59,
      -1,    -1,    62,    63,    64,    65,    66,    67,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,
      -1,    -1,    -1,   103,    -1,   105,   106,   107,   108,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   128,    -1,
      -1,   131,   132,   133,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,
     160,    -1,    -1,    -1,    -1,   165,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   181,    -1,    -1,    -1,   185,    -1,   187,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   207,   208,    -1,
     210,    -1,   212,    -1,    -1,    -1,    -1,    -1,   218,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    13,   242,    15,    16,    -1,    18,    19,    -1,    21,
      22,    23,    24,    -1,    26,    27,    28,    29,    30,    31,
      -1,    33,    34,   263,   264,    37,    38,    39,    40,    41,
      42,    -1,    -1,    -1,    46,    47,   276,    -1,    -1,    -1,
      -1,    -1,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,     6,    -1,    -1,    71,
      -1,    -1,    -1,    13,    -1,    15,    16,    -1,    18,    19,
      -1,    21,    22,    23,    24,    -1,    26,    27,    28,    29,
      30,    31,    -1,    33,    34,    -1,    -1,    37,    38,    39,
      40,    41,    42,    -1,    -1,    -1,    46,    47,    -1,    -1,
      -1,    -1,    -1,    -1,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    -1,    -1,
      -1,    71
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     6,    13,    15,    16,    18,    19,    21,    22,
      23,    24,    26,    27,    28,    29,    30,    31,    33,    34,
      37,    38,    39,    40,    41,    42,    46,    47,    54,    55,
      56,    59,    60,    61,    62,    63,    65,    66,    67,    71,
      73,    74,    75,    76,   108,   109,    74,     7,   111,    12,
     106,     6,     6,     7,     8,    10,    99,    20,    99,    99,
      25,    99,   100,    99,    99,    99,    99,    99,     7,    32,
      96,     8,     9,    98,   102,    51,     6,    17,    25,    85,
      97,    35,    36,    51,    58,    68,    84,    86,    89,    99,
       7,    11,    90,     7,   101,    84,    99,    99,   104,    99,
       6,   106,    57,    35,    92,    99,    99,    99,    99,     6,
       6,     6,   102,     0,     5,    74,     6,    76,   108,   110,
     113,     5,   104,   102,     6,    99,    20,    99,    99,   100,
      99,    99,    99,    99,    99,    32,   102,     6,    84,    86,
      87,    98,     6,    97,    99,    25,    45,    89,    87,    87,
       6,    98,    90,     6,    98,     6,    85,    99,   104,     6,
      99,     6,     6,    99,     6,    99,    99,    99,    99,     6,
      14,   112,   110,     6,    96,    98,    98,    98,   106,   107,
      69,    99,    25,    69,    96,    99,    99,    99,    99,     7,
      48,    91,     8,    83,    87,    98,    83,    87,     6,    98,
       6,    99,     6,     6,    90,   101,   106,    99,    99,    98,
      99,    99,    99,    25,   111,    98,   101,     7,    69,    70,
      77,    78,    96,   101,     6,   107,   107,     6,     6,     8,
      99,    98,     6,     8,    49,    50,    52,    79,    93,    98,
       7,    96,    99,    96,    99,    96,    98,    91,     6,    87,
      98,    87,    98,     6,    99,    99,    92,    99,    96,    99,
      96,     6,     6,     9,    99,   103,    98,     6,     6,   101,
       6,     6,   103,    98,     6,    25,   105,    93,    98,    98,
      93,    93,    49,    50,    52,    53,    80,    94,    98,    96,
      99,    94,    96,    94,    91,    43,    96,   101,   101,    96,
      49,    64,    88,   103,   103,     6,    98,     6,     6,     6,
     105,   103,    93,    94,    98,    98,    98,    94,    94,    94,
      96,    49,    50,    52,    53,    81,    95,    98,    44,     6,
       6,    50,    82,     6,    88,     6,     6,    98,    94,    94,
      94,    95,    98,    98,    98,    95,    95,     6,    98,     6,
       6,    98,    95,    95,    98,    98,    98,    98
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    72,    73,    73,    73,    73,    74,    74,    75,    75,
      75,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    84,    84,    85,    85,    86,    86,    86,
      87,    87,    87,    87,    87,    88,    88,    88,    89,    89,
      89,    90,    90,    90,    91,    91,    91,    92,    92,    93,
      93,    93,    93,    93,    94,    94,    94,    94,    94,    94,
      95,    95,    95,    95,    95,    95,    96,    96,    97,    98,
      98,    99,    99,    99,   100,   100,   101,   101,   102,   102,
     103,   103,   103,   104,   104,   105,   105,   106,   107,   107,
     108,   109,   110,   110,   111,   112,   112,   113,   113,   113
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     3,     1,     2,     0,     2,     1,     1,
       1,     6,     7,     6,     6,     6,     6,     7,     5,     5,
       6,     7,     5,     7,     8,     5,     6,     5,     5,     6,
       6,     7,     8,     7,     6,     3,     4,     3,     2,     3,
       4,     4,     3,     4,     3,     3,     3,     5,     8,     3,
       8,     7,     7,     7,     7,     8,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     2,     3,     2,     3,     4,
       5,     2,     1,     2,     3,     1,     1,     2,     1,     1,
       0,     2,     3,     2,     3,     0,     1,     1,     0,     2,
       2,     0,     2,     3,     0,     2,     3,     0,     4,     0,
       3,     2,     2,     2,     0,     3,     2,     2,     2,     3,
       0,     3,     3,     2,     2,     2,     1,     1,     4,     1,
       1,     1,     1,     1,     1,     1,     0,     3,     0,     2,
       0,     2,     2,     0,     2,     0,     2,     2,     0,     2,
       3,     4,     0,     2,     1,     1,     2,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Input: InputList End  */
#line 182 "parse_spice.ypp"
                {
  }
#line 1811 "parse_spice.cpp"
    break;

  case 3: /* Input: TitleLine InputList End  */
#line 184 "parse_spice.ypp"
                            {
    spice_title = (yyvsp[-2].str);
  }
#line 1819 "parse_spice.cpp"
    break;

  case 4: /* Input: InputList  */
#line 187 "parse_spice.ypp"
              {
    fprintf (stderr, "spice notice, no .END directive found, continuing\n");
  }
#line 1827 "parse_spice.cpp"
    break;

  case 5: /* Input: TitleLine InputList  */
#line 190 "parse_spice.ypp"
                        {
    spice_title = (yyvsp[-1].str);
    fprintf (stderr, "spice notice, no .END directive found, continuing\n");
  }
#line 1836 "parse_spice.cpp"
    break;

  case 8: /* InputLine: Subcircuit  */
#line 201 "parse_spice.ypp"
             {
    /* chain definition root */
    (yyvsp[0].definition)->next = definition_root;
    definition_root = (yyvsp[0].definition);
  }
#line 1846 "parse_spice.cpp"
    break;

  case 9: /* InputLine: DefinitionLine  */
#line 206 "parse_spice.ypp"
                   {
    /* chain definition root */
    if ((yyvsp[0].definition)) {
      (yyvsp[0].definition)->next = definition_root;
      definition_root = (yyvsp[0].definition);
    }
  }
#line 1858 "parse_spice.cpp"
    break;

  case 10: /* InputLine: Eol  */
#line 213 "parse_spice.ypp"
        { /* nothing to do here */ }
#line 1864 "parse_spice.cpp"
    break;

  case 11: /* DefinitionLine: RLC_Device Node Node Value PairList Eol  */
#line 217 "parse_spice.ypp"
                                          {
    /* R, L and C definitions */
    (yyval.definition) = spice_create_device ((yyvsp[-5].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_val_value ((yyval.definition), (yyvsp[-2].ident), HINT_NUMBER);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 1877 "parse_spice.cpp"
    break;

  case 12: /* DefinitionLine: RLC_Device Node Node Value MODEL_Ident PairList Eol  */
#line 225 "parse_spice.ypp"
                                                        {
    /* R, L and C definitions specified by a Model */
    (yyval.definition) = spice_create_device ((yyvsp[-6].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_val_value ((yyval.definition), (yyvsp[-3].ident), HINT_NUMBER);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 1891 "parse_spice.cpp"
    break;

  case 13: /* DefinitionLine: RLC_Device Node Node MODEL_Ident Value Eol  */
#line 234 "parse_spice.ypp"
                                               {
    /* R, L and C definitions specified by a Model, a variant */
    (yyval.definition) = spice_create_device ((yyvsp[-5].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_val_value ((yyval.definition), (yyvsp[-1].ident), HINT_NUMBER);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
  }
#line 1904 "parse_spice.cpp"
    break;

  case 14: /* DefinitionLine: RLC_Device Node Node MODEL_Ident PairList Eol  */
#line 242 "parse_spice.ypp"
                                                  {
    /* R definitions specified by a Model, yet another variant */
    (yyval.definition) = spice_create_device ((yyvsp[-5].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 1917 "parse_spice.cpp"
    break;

  case 15: /* DefinitionLine: RLC_Device Node Node Value TC_Value_1 Eol  */
#line 250 "parse_spice.ypp"
                                              {
    /* R definitions including TC1 */
    (yyval.definition) = spice_create_device ((yyvsp[-5].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_val_value ((yyval.definition), (yyvsp[-2].ident), HINT_NUMBER);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 1930 "parse_spice.cpp"
    break;

  case 16: /* DefinitionLine: RLC_Device Node Node Value TC_Value_2 Eol  */
#line 258 "parse_spice.ypp"
                                              {
    /* R definitions including TC1/TC2 */
    (yyval.definition) = spice_create_device ((yyvsp[-5].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_val_value ((yyval.definition), (yyvsp[-2].ident), HINT_NUMBER);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 1943 "parse_spice.cpp"
    break;

  case 17: /* DefinitionLine: RLC_Device Node Node Value Behave NodeValueList Eol  */
#line 266 "parse_spice.ypp"
                                                        {
    /* non-linear C and L poly definitions */
    (yyval.definition) = spice_create_device ((yyvsp[-6].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_val_value ((yyval.definition), (yyvsp[-3].ident), HINT_NUMBER);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 1957 "parse_spice.cpp"
    break;

  case 18: /* DefinitionLine: K_Device L_Device L_Device Value Eol  */
#line 275 "parse_spice.ypp"
                                         {
    /* Mutual inductors */
    (yyval.definition) = spice_create_device ((yyvsp[-4].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NAME);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    spice_append_val_value ((yyval.definition), (yyvsp[-1].ident), HINT_NUMBER);
  }
#line 1969 "parse_spice.cpp"
    break;

  case 19: /* DefinitionLine: IV_Source Node Node ExprList Eol  */
#line 282 "parse_spice.ypp"
                                     {
    /* independent current/voltage sources */
    (yyval.definition) = spice_create_device ((yyvsp[-4].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 1981 "parse_spice.cpp"
    break;

  case 20: /* DefinitionLine: IV_Source Node Node Value ExprList Eol  */
#line 289 "parse_spice.ypp"
                                           {
    /* independent current/voltage sources given the value */
    (yyval.definition) = spice_create_device ((yyvsp[-5].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_val_value ((yyval.definition), (yyvsp[-2].ident), HINT_NUMBER);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 1994 "parse_spice.cpp"
    break;

  case 21: /* DefinitionLine: GE_Source Node Node Behave Digits NodeValueList Eol  */
#line 297 "parse_spice.ypp"
                                                        {
    /* voltage controlled source POLY */
    if (!strcasecmp ((yyvsp[-3].ident), "POLY")) {
      (yyval.definition) = spice_create_device ((yyvsp[-6].ident));
      spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
      spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
      spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NAME);
      spice_append_val_value ((yyval.definition), (yyvsp[-2].ident), HINT_NUMBER);
      (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
    }
    else {
      fprintf (stderr, "spice notice, behavioural %s source ignored\n", (yyvsp[-6].ident));
      (yyval.definition) = NULL;
    }
  }
#line 2014 "parse_spice.cpp"
    break;

  case 22: /* DefinitionLine: GE_Source Node Node Behave Eol  */
#line 312 "parse_spice.ypp"
                                   {
    /* voltage controlled sources OTHER behavioural */
    fprintf (stderr, "spice notice, behavioural %s source ignored\n", (yyvsp[-4].ident));
    (yyval.definition) = NULL;
  }
#line 2024 "parse_spice.cpp"
    break;

  case 23: /* DefinitionLine: GE_Source Node Node Node Node Value Eol  */
#line 317 "parse_spice.ypp"
                                            {
    /* voltage controlled sources */
    (yyval.definition) = spice_create_device ((yyvsp[-6].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    spice_append_val_value ((yyval.definition), (yyvsp[-1].ident), HINT_NUMBER);
  }
#line 2038 "parse_spice.cpp"
    break;

  case 24: /* DefinitionLine: FH_Source FH_Node FH_Node Behave Digits VSourceList NodeValueList Eol  */
#line 326 "parse_spice.ypp"
                                                                          {
    /* current controlled source POLY */
    if (!strcasecmp ((yyvsp[-4].ident), "POLY")) {
      (yyval.definition) = spice_create_device ((yyvsp[-7].ident));
      spice_append_str_value ((yyval.definition), (yyvsp[-6].ident), HINT_NODE);
      spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
      spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NAME);
      spice_append_val_value ((yyval.definition), (yyvsp[-3].ident), HINT_NUMBER);
      (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-2].value));
      (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
    }
    else {
      fprintf (stderr, "spice notice, behavioural %s source ignored\n", (yyvsp[-7].ident));
      (yyval.definition) = NULL;
    }
  }
#line 2059 "parse_spice.cpp"
    break;

  case 25: /* DefinitionLine: FH_Source FH_Node FH_Node Behave Eol  */
#line 342 "parse_spice.ypp"
                                         {
    /* current controlled sources OTHER behavioural */
    fprintf (stderr, "spice notice, behavioural %s source ignored\n", (yyvsp[-4].ident));
    (yyval.definition) = NULL;
  }
#line 2069 "parse_spice.cpp"
    break;

  case 26: /* DefinitionLine: FH_Source FH_Node FH_Node V_Source Value Eol  */
#line 347 "parse_spice.ypp"
                                                 {
    /* current controlled sources */
    (yyval.definition) = spice_create_device ((yyvsp[-5].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    spice_append_val_value ((yyval.definition), (yyvsp[-1].ident), HINT_NUMBER);
  }
#line 2082 "parse_spice.cpp"
    break;

  case 27: /* DefinitionLine: MODEL_Action MODEL_Ident MODEL_Spec MODEL_List Eol  */
#line 355 "parse_spice.ypp"
                                                       {
    /* device specification */
    (yyval.definition) = spice_create_action ((yyvsp[-4].ident), (yyvsp[-3].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME | HINT_MSTART);
    spice_add_last_hint ((yyvsp[-1].value), HINT_MSTOP);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 2094 "parse_spice.cpp"
    break;

  case 28: /* DefinitionLine: Diode_Device Node Node MODEL_Ident DEVICE_List_1  */
#line 362 "parse_spice.ypp"
                                                     {
    /* diode */
    (yyval.definition) = spice_create_device ((yyvsp[-4].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-1].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[0].value));
  }
#line 2107 "parse_spice.cpp"
    break;

  case 29: /* DefinitionLine: JFET_Device Node Node Node MODEL_Ident DEVICE_List_2  */
#line 370 "parse_spice.ypp"
                                                         {
    /* JFET */
    (yyval.definition) = spice_create_device ((yyvsp[-5].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-1].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[0].value));
  }
#line 2121 "parse_spice.cpp"
    break;

  case 30: /* DefinitionLine: Bipolar_Device Node Node Node MODEL_Ident DEVICE_List_2  */
#line 379 "parse_spice.ypp"
                                                            {
    /* 3 node BJT */
    (yyval.definition) = spice_create_device ((yyvsp[-5].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-1].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[0].value));
  }
#line 2135 "parse_spice.cpp"
    break;

  case 31: /* DefinitionLine: Bipolar_Device Node Node Node Node MODEL_Ident DEVICE_List_2  */
#line 388 "parse_spice.ypp"
                                                                 {
    /* 4 node BJT */
    (yyval.definition) = spice_create_device ((yyvsp[-6].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-1].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[0].value));
  }
#line 2150 "parse_spice.cpp"
    break;

  case 32: /* DefinitionLine: Bipolar_Device Node Node Node Node Node MODEL_Ident DEVICE_List_2  */
#line 398 "parse_spice.ypp"
                                                                      {
    /* 5 node BJT */
    (yyval.definition) = spice_create_device ((yyvsp[-7].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-6].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-1].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[0].value));
  }
#line 2166 "parse_spice.cpp"
    break;

  case 33: /* DefinitionLine: MOSFET_Device Node Node Node Node MODEL_Ident DEVICE_List_3  */
#line 409 "parse_spice.ypp"
                                                                {
    /* MOS */
    (yyval.definition) = spice_create_device ((yyvsp[-6].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-1].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[0].value));
  }
#line 2181 "parse_spice.cpp"
    break;

  case 34: /* DefinitionLine: MESFET_Device Node Node Node MODEL_Ident DEVICE_List_2  */
#line 419 "parse_spice.ypp"
                                                           {
    /* MES */
    (yyval.definition) = spice_create_device ((yyvsp[-5].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-1].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[0].value));
  }
#line 2195 "parse_spice.cpp"
    break;

  case 35: /* DefinitionLine: TRAN_Action ValueList Eol  */
#line 428 "parse_spice.ypp"
                              {
    /* transient analysis */
    (yyval.definition) = spice_create_action ((yyvsp[-2].ident), strdup ((yyvsp[-2].ident)));
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 2205 "parse_spice.cpp"
    break;

  case 36: /* DefinitionLine: PLOT_Action SIM_Type PLOT_List Eol  */
#line 433 "parse_spice.ypp"
                                       {
    /* plotting */
    (yyval.definition) = spice_create_action ((yyvsp[-3].ident), strdup ((yyvsp[-3].ident)));
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 2216 "parse_spice.cpp"
    break;

  case 37: /* DefinitionLine: AC_Action Expr Eol  */
#line 439 "parse_spice.ypp"
                       {
    /* AC analysis */
    (yyval.definition) = spice_create_action ((yyvsp[-2].ident), strdup ((yyvsp[-2].ident)));
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 2226 "parse_spice.cpp"
    break;

  case 38: /* DefinitionLine: DC_Action Eol  */
#line 444 "parse_spice.ypp"
                  {
    /* single DC analysis */
    (yyval.definition) = spice_create_action ((yyvsp[-1].ident), strdup ((yyvsp[-1].ident)));
  }
#line 2235 "parse_spice.cpp"
    break;

  case 39: /* DefinitionLine: DC_Action DC_List Eol  */
#line 448 "parse_spice.ypp"
                          {
    /* DC analysis first order */
    (yyval.definition) = spice_create_action ((yyvsp[-2].ident), strdup ((yyvsp[-2].ident)));
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 2245 "parse_spice.cpp"
    break;

  case 40: /* DefinitionLine: DC_Action DC_List DC_List Eol  */
#line 453 "parse_spice.ypp"
                                  {
    /* DC analysis second order */
    (yyval.definition) = spice_create_action ((yyvsp[-3].ident), strdup ((yyvsp[-3].ident)));
    (yyval.definition)->values = netlist_append_values ((yyvsp[-2].value), (yyvsp[-1].value));
  }
#line 2255 "parse_spice.cpp"
    break;

  case 41: /* DefinitionLine: PRINT_Action SIM_Type PRINT_List Eol  */
#line 458 "parse_spice.ypp"
                                         {
    /* printing specifying the analysis type */
    (yyval.definition) = spice_create_action ((yyvsp[-3].ident), strdup ((yyvsp[-3].ident)));
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 2266 "parse_spice.cpp"
    break;

  case 42: /* DefinitionLine: PRINT_Action PRINT_List Eol  */
#line 464 "parse_spice.ypp"
                                {
    /* printing */
    (yyval.definition) = spice_create_action ((yyvsp[-2].ident), strdup ((yyvsp[-2].ident)));
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 2276 "parse_spice.cpp"
    break;

  case 43: /* DefinitionLine: PRINT_Action SIM_Type ALL_Special Eol  */
#line 469 "parse_spice.ypp"
                                          {
    /* printing */
    (yyval.definition) = spice_create_action ((yyvsp[-3].ident), strdup ((yyvsp[-3].ident)));
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    spice_append_str_value ((yyval.definition), (yyvsp[-1].ident), HINT_NAME);
  }
#line 2287 "parse_spice.cpp"
    break;

  case 44: /* DefinitionLine: OPTIONS_Action OPTIONS_List Eol  */
#line 475 "parse_spice.ypp"
                                    {
    /* general analysis options */
    (yyval.definition) = spice_create_action ((yyvsp[-2].ident), strdup ((yyvsp[-2].ident)));
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 2297 "parse_spice.cpp"
    break;

  case 45: /* DefinitionLine: TEMP_Action ValueList Eol  */
#line 480 "parse_spice.ypp"
                              {
    /* temperatur analysis (Spice 2g6) */
    (yyval.definition) = spice_create_action ((yyvsp[-2].ident), strdup ((yyvsp[-2].ident)));
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 2307 "parse_spice.cpp"
    break;

  case 46: /* DefinitionLine: WIDTH_Action PairList Eol  */
#line 485 "parse_spice.ypp"
                              {
    /* TODO: default width of ??? */
    (yyval.definition) = spice_create_action ((yyvsp[-2].ident), strdup ((yyvsp[-2].ident)));
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 2317 "parse_spice.cpp"
    break;

  case 47: /* DefinitionLine: NOISE_Action VOLTAGE_Output IV_Reference Expr Eol  */
#line 490 "parse_spice.ypp"
                                                      {
    /* noise analysis */
    (yyval.definition) = spice_create_action ((yyvsp[-4].ident), strdup ((yyvsp[-4].ident)));
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-3].value));
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 2329 "parse_spice.cpp"
    break;

  case 48: /* DefinitionLine: PZ_Action Node Node Node Node CurVol PoleZero Eol  */
#line 497 "parse_spice.ypp"
                                                      {
    /* pole-zero analysis */
    (yyval.definition) = spice_create_action ((yyvsp[-7].ident), strdup ((yyvsp[-7].ident)));
    spice_append_str_value ((yyval.definition), (yyvsp[-6].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    spice_append_str_value ((yyval.definition), (yyvsp[-1].ident), HINT_NAME);
  }
#line 2344 "parse_spice.cpp"
    break;

  case 49: /* DefinitionLine: X_Device NodeList Eol  */
#line 507 "parse_spice.ypp"
                          {
    /* subcircuit call */
    (yyval.definition) = spice_create_device ((yyvsp[-2].ident));
    spice_set_last_hint ((yyvsp[-1].value), HINT_NAME);
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 2355 "parse_spice.cpp"
    break;

  case 50: /* DefinitionLine: S_Device Node Node Node Node MODEL_Ident SWITCH_State Eol  */
#line 513 "parse_spice.ypp"
                                                              {
    /* voltage controlled switch */
    (yyval.definition) = spice_create_device ((yyvsp[-7].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-6].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 2370 "parse_spice.cpp"
    break;

  case 51: /* DefinitionLine: W_Device Node Node V_Source MODEL_Ident SWITCH_State Eol  */
#line 523 "parse_spice.ypp"
                                                             {
    /* current controlled switch */
    (yyval.definition) = spice_create_device ((yyvsp[-6].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NAME);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 2384 "parse_spice.cpp"
    break;

  case 52: /* DefinitionLine: O_Device Node Node Node Node MODEL_Ident Eol  */
#line 532 "parse_spice.ypp"
                                                 {
    /* lossy transline */
    (yyval.definition) = spice_create_device ((yyvsp[-6].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-1].ident), HINT_NAME);
  }
#line 2398 "parse_spice.cpp"
    break;

  case 53: /* DefinitionLine: U_Device Node Node Node MODEL_Ident PairList Eol  */
#line 541 "parse_spice.ypp"
                                                     {
    /* distributed lossy transline */
    (yyval.definition) = spice_create_device ((yyvsp[-6].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NAME);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 2412 "parse_spice.cpp"
    break;

  case 54: /* DefinitionLine: T_Device Node Node Node Node PairList Eol  */
#line 550 "parse_spice.ypp"
                                              {
    /* lossless transline */
    (yyval.definition) = spice_create_device ((yyvsp[-6].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-2].ident), HINT_NODE);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 2426 "parse_spice.cpp"
    break;

  case 55: /* DefinitionLine: T_Device Node Node Node Node PairList IC_Condition_4 Eol  */
#line 559 "parse_spice.ypp"
                                                             {
    /* lossless transline and initial condition */
    (yyval.definition) = spice_create_device ((yyvsp[-7].ident));
    spice_append_str_value ((yyval.definition), (yyvsp[-6].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-5].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-4].ident), HINT_NODE);
    spice_append_str_value ((yyval.definition), (yyvsp[-3].ident), HINT_NODE);
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-2].value));
    (yyval.definition)->values = netlist_append_values ((yyval.definition)->values, (yyvsp[-1].value));
  }
#line 2441 "parse_spice.cpp"
    break;

  case 56: /* DefinitionLine: OP_Action Eol  */
#line 569 "parse_spice.ypp"
                  {
    /* operating point analysis */
    (yyval.definition) = spice_create_action ((yyvsp[-1].ident), strdup ((yyvsp[-1].ident)));
  }
#line 2450 "parse_spice.cpp"
    break;

  case 57: /* DefinitionLine: SAVE_Action Eol  */
#line 573 "parse_spice.ypp"
                    {
    /* saving action */
    (yyval.definition) = spice_create_action ((yyvsp[-1].ident), strdup ((yyvsp[-1].ident)));
  }
#line 2459 "parse_spice.cpp"
    break;

  case 58: /* DefinitionLine: SENS_Action Eol  */
#line 577 "parse_spice.ypp"
                    {
    /* sensitivity analysis */
    (yyval.definition) = spice_create_action ((yyvsp[-1].ident), strdup ((yyvsp[-1].ident)));
  }
#line 2468 "parse_spice.cpp"
    break;

  case 59: /* DefinitionLine: TF_Action Eol  */
#line 581 "parse_spice.ypp"
                  {
    /* transfer function analysis */
    (yyval.definition) = spice_create_action ((yyvsp[-1].ident), strdup ((yyvsp[-1].ident)));
  }
#line 2477 "parse_spice.cpp"
    break;

  case 60: /* DefinitionLine: FOUR_Action Eol  */
#line 585 "parse_spice.ypp"
                    {
    /* fourier analysis */
    (yyval.definition) = spice_create_action ((yyvsp[-1].ident), strdup ((yyvsp[-1].ident)));
  }
#line 2486 "parse_spice.cpp"
    break;

  case 61: /* DefinitionLine: B_Source Eol  */
#line 589 "parse_spice.ypp"
                 {
    /* non-linear dependent sources */
    (yyval.definition) = spice_create_device ((yyvsp[-1].ident));
  }
#line 2495 "parse_spice.cpp"
    break;

  case 62: /* DefinitionLine: DISTO_Action Expr Eol  */
#line 593 "parse_spice.ypp"
                          {
    /* distortion analysis */
    (yyval.definition) = spice_create_action ((yyvsp[-2].ident), strdup ((yyvsp[-2].ident)));
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 2505 "parse_spice.cpp"
    break;

  case 63: /* DefinitionLine: INCLUDE_Action File Eol  */
#line 598 "parse_spice.ypp"
                            {
    /* file include */
    (yyval.definition) = spice_create_action ((yyvsp[-2].ident), strdup ((yyvsp[-2].ident)));
    struct value_t * file = create_value ();
    file->ident = (yyvsp[-1].ident);
    file->hint = HINT_NAME;
    (yyval.definition)->values = file;
  }
#line 2518 "parse_spice.cpp"
    break;

  case 64: /* DefinitionLine: NODESET_Action NODESET_List Eol  */
#line 606 "parse_spice.ypp"
                                    {
    /* nodeset functionality */
    (yyval.definition) = spice_create_action ((yyvsp[-2].ident), strdup ((yyvsp[-2].ident)));
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 2528 "parse_spice.cpp"
    break;

  case 65: /* TC_Value_1: TC_Special Value  */
#line 614 "parse_spice.ypp"
                   {
    (yyval.value) = NULL;
    (yyval.value) = spice_create_par_value ((yyvsp[-1].ident), (yyvsp[0].ident));
  }
#line 2537 "parse_spice.cpp"
    break;

  case 66: /* TC_Value_2: TC_Special Value Value  */
#line 621 "parse_spice.ypp"
                         {
    (yyval.value) = NULL;
    (yyval.value) = spice_create_par_value ((yyvsp[-2].ident), (yyvsp[-1].ident));
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[0].ident), HINT_NUMBER);
  }
#line 2547 "parse_spice.cpp"
    break;

  case 67: /* IC_Condition_1: IC_Special Value  */
#line 629 "parse_spice.ypp"
                   {
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-1].ident), HINT_NAME);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[0].ident), HINT_NUMBER);
  }
#line 2557 "parse_spice.cpp"
    break;

  case 68: /* IC_Condition_2: IC_Special Value Value  */
#line 637 "parse_spice.ypp"
                         {
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-2].ident), HINT_NAME);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[-1].ident), HINT_NUMBER);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[0].ident), HINT_NUMBER);
  }
#line 2568 "parse_spice.cpp"
    break;

  case 69: /* IC_Condition_3: IC_Special Value Value Value  */
#line 645 "parse_spice.ypp"
                               {
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-3].ident), HINT_NAME);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[-2].ident), HINT_NUMBER);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[-1].ident), HINT_NUMBER);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[0].ident), HINT_NUMBER);
  }
#line 2580 "parse_spice.cpp"
    break;

  case 70: /* IC_Condition_4: IC_Special Value Value Value Value  */
#line 655 "parse_spice.ypp"
                                     {
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-4].ident), HINT_NAME);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[-3].ident), HINT_NUMBER);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[-2].ident), HINT_NUMBER);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[-1].ident), HINT_NUMBER);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[0].ident), HINT_NUMBER);
  }
#line 2593 "parse_spice.cpp"
    break;

  case 71: /* Output_Range: Value Value  */
#line 666 "parse_spice.ypp"
              { /* range specification during plotting */
    (yyval.value) = NULL;
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[-1].ident), HINT_NUMBER);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[0].ident), HINT_NUMBER);
  }
#line 2603 "parse_spice.cpp"
    break;

  case 72: /* VOLTAGE_Output: Node  */
#line 674 "parse_spice.ypp"
       { // TODO: 2 reduce/reduce, 2 shift/reduce
    /* print/plot specification of node voltage */
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), strdup ("V"), HINT_NAME | HINT_MSTART);
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[0].ident), HINT_NODE | HINT_MSTOP);
  }
#line 2614 "parse_spice.cpp"
    break;

  case 73: /* VOLTAGE_Output: VoltFunc Node  */
#line 680 "parse_spice.ypp"
                  { // TODO: 2 reduce/reduce
    /* print/plot specification of node voltage */
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-1].ident), HINT_NAME | HINT_MSTART);
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[0].ident), HINT_NODE | HINT_MSTOP);
  }
#line 2625 "parse_spice.cpp"
    break;

  case 74: /* VOLTAGE_Output: VoltFunc Node Node  */
#line 686 "parse_spice.ypp"
                       {
    /* print/plot specification of differential node voltages */
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-2].ident), HINT_NAME | HINT_MSTART);
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-1].ident), HINT_NODE);
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[0].ident), HINT_NODE | HINT_MSTOP);    
  }
#line 2637 "parse_spice.cpp"
    break;

  case 77: /* CURRENT_Output: CurrFunc V_Source  */
#line 699 "parse_spice.ypp"
                    {
    /* print/plot specification of branch current */
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-1].ident), HINT_NAME | HINT_MSTART);
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[0].ident), HINT_NAME | HINT_MSTOP);
  }
#line 2648 "parse_spice.cpp"
    break;

  case 78: /* CURRENT_Output: BranchFunc  */
#line 705 "parse_spice.ypp"
               {
    /* print/plot specification of branch current */
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), strdup ("I"), HINT_NAME | HINT_MSTART);
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[0].ident), HINT_NAME | HINT_MSTOP);
  }
#line 2659 "parse_spice.cpp"
    break;

  case 79: /* CURRENT_Output: OpFunc  */
#line 711 "parse_spice.ypp"
           {
    /* print/plot specification of operating point */
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), strdup ("OP"), HINT_NAME | HINT_MSTART);
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[0].ident), HINT_NAME | HINT_MSTOP);
  }
#line 2670 "parse_spice.cpp"
    break;

  case 80: /* PLOT_List: %empty  */
#line 719 "parse_spice.ypp"
                         { (yyval.value) = NULL; }
#line 2676 "parse_spice.cpp"
    break;

  case 81: /* PLOT_List: VOLTAGE_Output PLOT_List  */
#line 720 "parse_spice.ypp"
                             {
    (yyval.value) = netlist_append_values ((yyvsp[-1].value), (yyvsp[0].value));
  }
#line 2684 "parse_spice.cpp"
    break;

  case 82: /* PLOT_List: VOLTAGE_Output Output_Range PLOT_List  */
#line 723 "parse_spice.ypp"
                                          {
    (yyval.value) = netlist_append_values ((yyvsp[-2].value), (yyvsp[-1].value));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2693 "parse_spice.cpp"
    break;

  case 83: /* PLOT_List: CURRENT_Output PLOT_List  */
#line 727 "parse_spice.ypp"
                             {
    (yyval.value) = netlist_append_values ((yyvsp[-1].value), (yyvsp[0].value));
  }
#line 2701 "parse_spice.cpp"
    break;

  case 84: /* PLOT_List: CURRENT_Output Output_Range PLOT_List  */
#line 730 "parse_spice.ypp"
                                          {
    (yyval.value) = netlist_append_values ((yyvsp[-2].value), (yyvsp[-1].value));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2710 "parse_spice.cpp"
    break;

  case 85: /* SWITCH_State: %empty  */
#line 736 "parse_spice.ypp"
                            { (yyval.value) = NULL; }
#line 2716 "parse_spice.cpp"
    break;

  case 86: /* SWITCH_State: ON_Special  */
#line 737 "parse_spice.ypp"
               {
    (yyval.value) = spice_create_str_value ((yyvsp[0].ident), HINT_NAME);
  }
#line 2724 "parse_spice.cpp"
    break;

  case 87: /* SWITCH_State: OFF_Special  */
#line 740 "parse_spice.ypp"
                {
    (yyval.value) = spice_create_str_value ((yyvsp[0].ident), HINT_NAME);
  }
#line 2732 "parse_spice.cpp"
    break;

  case 88: /* PRINT_List: %empty  */
#line 745 "parse_spice.ypp"
                          { (yyval.value) = NULL; }
#line 2738 "parse_spice.cpp"
    break;

  case 89: /* PRINT_List: VOLTAGE_Output PLOT_List  */
#line 746 "parse_spice.ypp"
                             {
    (yyval.value) = netlist_append_values ((yyvsp[-1].value), (yyvsp[0].value));
  }
#line 2746 "parse_spice.cpp"
    break;

  case 90: /* PRINT_List: CURRENT_Output PLOT_List  */
#line 749 "parse_spice.ypp"
                             {
    (yyval.value) = netlist_append_values ((yyvsp[-1].value), (yyvsp[0].value));
  }
#line 2754 "parse_spice.cpp"
    break;

  case 91: /* OPTIONS_List: %empty  */
#line 754 "parse_spice.ypp"
                            { (yyval.value) = NULL; }
#line 2760 "parse_spice.cpp"
    break;

  case 92: /* OPTIONS_List: Options OPTIONS_List  */
#line 755 "parse_spice.ypp"
                         {
    (yyval.value) = spice_create_str_value ((yyvsp[-1].ident), HINT_NAME);
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2769 "parse_spice.cpp"
    break;

  case 93: /* OPTIONS_List: Identifier Value OPTIONS_List  */
#line 759 "parse_spice.ypp"
                                  {
    (yyval.value) = spice_create_par_value ((yyvsp[-2].ident), (yyvsp[-1].ident));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2778 "parse_spice.cpp"
    break;

  case 94: /* MODEL_List: %empty  */
#line 765 "parse_spice.ypp"
                          { (yyval.value) = NULL; }
#line 2784 "parse_spice.cpp"
    break;

  case 95: /* MODEL_List: ModelProps MODEL_List  */
#line 766 "parse_spice.ypp"
                          {
    (yyval.value) = spice_create_str_value ((yyvsp[-1].ident), HINT_NAME);
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2793 "parse_spice.cpp"
    break;

  case 96: /* MODEL_List: Identifier Value MODEL_List  */
#line 770 "parse_spice.ypp"
                                {
    (yyval.value) = spice_create_par_value ((yyvsp[-2].ident), (yyvsp[-1].ident));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2802 "parse_spice.cpp"
    break;

  case 97: /* NODESET_List: %empty  */
#line 776 "parse_spice.ypp"
                            { (yyval.value) = NULL; }
#line 2808 "parse_spice.cpp"
    break;

  case 98: /* NODESET_List: VoltFunc Node Value NODESET_List  */
#line 777 "parse_spice.ypp"
                                     {
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-3].ident), HINT_NAME | HINT_MSTART);
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-2].ident), HINT_NODE | HINT_MSTOP);
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-1].ident), HINT_NUMBER);
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2820 "parse_spice.cpp"
    break;

  case 99: /* DEVICE_List_1: %empty  */
#line 786 "parse_spice.ypp"
                             { (yyval.value) = NULL; }
#line 2826 "parse_spice.cpp"
    break;

  case 100: /* DEVICE_List_1: TEMP_Special Value DEVICE_List_1  */
#line 787 "parse_spice.ypp"
                                     {
    (yyval.value) = spice_create_par_value ((yyvsp[-2].ident), (yyvsp[-1].ident));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2835 "parse_spice.cpp"
    break;

  case 101: /* DEVICE_List_1: Value DEVICE_List_1  */
#line 791 "parse_spice.ypp"
                        {
    (yyval.value) = spice_create_par_value (strdup ("Area"), (yyvsp[-1].ident));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2844 "parse_spice.cpp"
    break;

  case 102: /* DEVICE_List_1: OFF_Special DEVICE_List_1  */
#line 795 "parse_spice.ypp"
                              {
    (yyval.value) = spice_create_val_value ((yyvsp[-1].ident), HINT_NAME);
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2853 "parse_spice.cpp"
    break;

  case 103: /* DEVICE_List_1: IC_Condition_1 DEVICE_List_1  */
#line 799 "parse_spice.ypp"
                                 {
    (yyval.value) = netlist_append_values ((yyvsp[-1].value), (yyvsp[0].value));
  }
#line 2861 "parse_spice.cpp"
    break;

  case 104: /* DEVICE_List_2: %empty  */
#line 804 "parse_spice.ypp"
                             { (yyval.value) = NULL; }
#line 2867 "parse_spice.cpp"
    break;

  case 105: /* DEVICE_List_2: TEMP_Special Value DEVICE_List_2  */
#line 805 "parse_spice.ypp"
                                     {
    (yyval.value) = spice_create_par_value ((yyvsp[-2].ident), (yyvsp[-1].ident));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2876 "parse_spice.cpp"
    break;

  case 106: /* DEVICE_List_2: Value DEVICE_List_2  */
#line 809 "parse_spice.ypp"
                        {
    (yyval.value) = spice_create_par_value (strdup ("Area"), (yyvsp[-1].ident));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2885 "parse_spice.cpp"
    break;

  case 107: /* DEVICE_List_2: OFF_Special DEVICE_List_2  */
#line 813 "parse_spice.ypp"
                              {
    (yyval.value) = spice_create_val_value ((yyvsp[-1].ident), HINT_NAME);
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2894 "parse_spice.cpp"
    break;

  case 108: /* DEVICE_List_2: IC_Condition_2 DEVICE_List_2  */
#line 817 "parse_spice.ypp"
                                 {
    (yyval.value) = netlist_append_values ((yyvsp[-1].value), (yyvsp[0].value));
  }
#line 2902 "parse_spice.cpp"
    break;

  case 109: /* DEVICE_List_2: MOS_Special Value DEVICE_List_2  */
#line 820 "parse_spice.ypp"
                                    {
    (yyval.value) = spice_create_par_value ((yyvsp[-2].ident), (yyvsp[-1].ident));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2911 "parse_spice.cpp"
    break;

  case 110: /* DEVICE_List_3: %empty  */
#line 826 "parse_spice.ypp"
                             { (yyval.value) = NULL; }
#line 2917 "parse_spice.cpp"
    break;

  case 111: /* DEVICE_List_3: TEMP_Special Value DEVICE_List_3  */
#line 827 "parse_spice.ypp"
                                     {
    (yyval.value) = spice_create_par_value ((yyvsp[-2].ident), (yyvsp[-1].ident));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2926 "parse_spice.cpp"
    break;

  case 112: /* DEVICE_List_3: MOS_Special Value DEVICE_List_3  */
#line 831 "parse_spice.ypp"
                                    {
    (yyval.value) = spice_create_par_value ((yyvsp[-2].ident), (yyvsp[-1].ident));
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2935 "parse_spice.cpp"
    break;

  case 113: /* DEVICE_List_3: Value DEVICE_List_3  */
#line 835 "parse_spice.ypp"
                        {
    (yyval.value) = spice_create_val_value ((yyvsp[-1].ident), HINT_NUMBER);
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2944 "parse_spice.cpp"
    break;

  case 114: /* DEVICE_List_3: OFF_Special DEVICE_List_3  */
#line 839 "parse_spice.ypp"
                              {
    (yyval.value) = spice_create_val_value ((yyvsp[-1].ident), HINT_NAME);
    (yyval.value) = netlist_append_values ((yyval.value), (yyvsp[0].value));
  }
#line 2953 "parse_spice.cpp"
    break;

  case 115: /* DEVICE_List_3: IC_Condition_3 DEVICE_List_3  */
#line 843 "parse_spice.ypp"
                                 {
    (yyval.value) = netlist_append_values ((yyvsp[-1].value), (yyvsp[0].value));
  }
#line 2961 "parse_spice.cpp"
    break;

  case 118: /* DC_List: IV_Reference Value Value Value  */
#line 851 "parse_spice.ypp"
                                 {
    /* identification of a DC sweep */
    (yyval.value) = NULL;
    (yyval.value) = spice_append_str_values ((yyval.value), (yyvsp[-3].ident), HINT_NAME | HINT_MSTART);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[-2].ident), HINT_NUMBER);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[-1].ident), HINT_NUMBER);
    (yyval.value) = spice_append_val_values ((yyval.value), (yyvsp[0].ident), HINT_NUMBER | HINT_MSTOP);
  }
#line 2974 "parse_spice.cpp"
    break;

  case 126: /* PairList: %empty  */
#line 867 "parse_spice.ypp"
                        { (yyval.value) = NULL; }
#line 2980 "parse_spice.cpp"
    break;

  case 127: /* PairList: Identifier Value PairList  */
#line 868 "parse_spice.ypp"
                              {
    (yyval.value) = spice_create_par_value ((yyvsp[-2].ident), (yyvsp[-1].ident));
    (yyval.value)->next = (yyvsp[0].value);
  }
#line 2989 "parse_spice.cpp"
    break;

  case 128: /* ValueList: %empty  */
#line 874 "parse_spice.ypp"
                         { (yyval.value) = NULL; }
#line 2995 "parse_spice.cpp"
    break;

  case 129: /* ValueList: Value ValueList  */
#line 875 "parse_spice.ypp"
                    {
    (yyval.value) = spice_create_val_value ((yyvsp[-1].ident), HINT_NUMBER);
    (yyval.value)->next = (yyvsp[0].value);
  }
#line 3004 "parse_spice.cpp"
    break;

  case 130: /* NodeValueList: %empty  */
#line 881 "parse_spice.ypp"
                             { (yyval.value) = NULL; }
#line 3010 "parse_spice.cpp"
    break;

  case 131: /* NodeValueList: Node NodeValueList  */
#line 882 "parse_spice.ypp"
                       {
    (yyval.value) = spice_create_str_value ((yyvsp[-1].ident), HINT_NODE);
    (yyval.value)->next = (yyvsp[0].value);
  }
#line 3019 "parse_spice.cpp"
    break;

  case 132: /* NodeValueList: Floats NodeValueList  */
#line 886 "parse_spice.ypp"
                         {
    (yyval.value) = spice_create_val_value ((yyvsp[-1].ident), HINT_NUMBER);
    (yyval.value)->next = (yyvsp[0].value);
  }
#line 3028 "parse_spice.cpp"
    break;

  case 133: /* NodeList: %empty  */
#line 892 "parse_spice.ypp"
                        { (yyval.value) = NULL; }
#line 3034 "parse_spice.cpp"
    break;

  case 134: /* NodeList: Node NodeList  */
#line 893 "parse_spice.ypp"
                  {
    (yyval.value) = spice_create_str_value ((yyvsp[-1].ident), HINT_NODE);
    (yyval.value)->next = (yyvsp[0].value);
  }
#line 3043 "parse_spice.cpp"
    break;

  case 135: /* VSourceList: %empty  */
#line 899 "parse_spice.ypp"
                           { (yyval.value) = NULL; }
#line 3049 "parse_spice.cpp"
    break;

  case 136: /* VSourceList: V_Source VSourceList  */
#line 900 "parse_spice.ypp"
                         {
    (yyval.value) = spice_create_str_value ((yyvsp[-1].ident), HINT_NAME);
    (yyval.value)->next = (yyvsp[0].value);
  }
#line 3058 "parse_spice.cpp"
    break;

  case 137: /* Expr: Function ValueList  */
#line 907 "parse_spice.ypp"
                     {
    (yyval.value) = spice_create_str_value ((yyvsp[-1].ident), HINT_NAME | HINT_MSTART);
    spice_add_last_hint ((yyvsp[0].value), HINT_MSTOP);
    (yyval.value)->next = (yyvsp[0].value);
  }
#line 3068 "parse_spice.cpp"
    break;

  case 138: /* ExprList: %empty  */
#line 914 "parse_spice.ypp"
                        { (yyval.value) = NULL; }
#line 3074 "parse_spice.cpp"
    break;

  case 139: /* ExprList: Expr ExprList  */
#line 915 "parse_spice.ypp"
                  {
    (yyval.value) = netlist_append_values ((yyvsp[-1].value), (yyvsp[0].value));
  }
#line 3082 "parse_spice.cpp"
    break;

  case 140: /* Subcircuit: BeginSub SubBody EndSub  */
#line 921 "parse_spice.ypp"
                          {
    (yyvsp[-2].definition)->sub = (yyvsp[-1].definition);
    (yyval.definition) = (yyvsp[-2].definition);
    (yyvsp[-1].definition) = NULL;
  }
#line 3092 "parse_spice.cpp"
    break;

  case 141: /* BeginSub: SUBCKT_Action SubCkt_Ident NodeList Eol  */
#line 929 "parse_spice.ypp"
                                          {
    (yyval.definition) = spice_create_action ((yyvsp[-3].ident), (yyvsp[-2].ident));
    (yyval.definition)->values = (yyvsp[-1].value);
  }
#line 3101 "parse_spice.cpp"
    break;

  case 142: /* SubBody: %empty  */
#line 935 "parse_spice.ypp"
                       { (yyval.definition) = NULL; }
#line 3107 "parse_spice.cpp"
    break;

  case 143: /* SubBody: SubBodyLine SubBody  */
#line 936 "parse_spice.ypp"
                        { /* chain definitions here */
    if ((yyvsp[-1].definition)) {
      (yyvsp[-1].definition)->next = (yyvsp[0].definition);
      (yyval.definition) = (yyvsp[-1].definition);
    }
    else {
      (yyval.definition) = (yyvsp[0].definition);
    }
  }
#line 3121 "parse_spice.cpp"
    break;

  case 145: /* EndSub: ENDS_Action  */
#line 950 "parse_spice.ypp"
                { /* nothing to do */ }
#line 3127 "parse_spice.cpp"
    break;

  case 146: /* EndSub: ENDS_Action SubCkt_Ident  */
#line 951 "parse_spice.ypp"
                             { free ((yyvsp[0].ident)); /* nothing to do */ }
#line 3133 "parse_spice.cpp"
    break;

  case 147: /* SubBodyLine: DefinitionLine  */
#line 955 "parse_spice.ypp"
                 { /* chain definitions here */
    if ((yyvsp[0].definition)) {
      (yyvsp[0].definition)->next = (yyval.definition);
      (yyval.definition) = (yyvsp[0].definition);
    }
  }
#line 3144 "parse_spice.cpp"
    break;

  case 148: /* SubBodyLine: Subcircuit  */
#line 961 "parse_spice.ypp"
               { /* do nothing here, see subcircuit rule */ }
#line 3150 "parse_spice.cpp"
    break;

  case 149: /* SubBodyLine: Eol  */
#line 962 "parse_spice.ypp"
        {
    (yyval.definition) = NULL;
  }
#line 3158 "parse_spice.cpp"
    break;


#line 3162 "parse_spice.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 967 "parse_spice.ypp"


int spice_error (const char * error) {
  fprintf (stderr, "line %d: %s\n", spice_lineno, error);
  return 0;
}
